/* fst2spp.f -- translated by f2c (version 19990503).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/*     real Fourier compont --> space-time spectra */

/*     X : 4D array */
/*           1st dim. - ? ,  2nd - x , 3rd - ? , 4th - t */
/*                           ^^^real fourier     ^^^real fourier */
/*     X(?,x,?,t):double Fouerier --> S(x,?,t): power spectrum, phase */
/*     S's 2nd dim:: 1 - nx/2:eastward, nx/2+1 - nx+1:westward */

/*     real Fourier component is assumed to be in order as in FTRUMN */

/*     1993/11/17  horinout FST2SP:power spectrum FST2PH:phase */
/* ********************************************************************** */

/* Subroutine */ int fst2sp_(real *sp, real *x, integer *n1, integer *nx, 
	integer *n3, integer *nt)
{
    /* System generated locals */
    integer x_dim1, x_dim2, x_dim3, x_offset, sp_dim1, sp_dim2, sp_dim3, 
	    sp_offset, i__1, i__2, i__3, i__4;
    real r__1, r__2;

    /* Local variables */
    static integer i__, j, k, n;
    static real p, q, r__, s;
    extern /* Subroutine */ int msgdmp_(char *, char *, char *, ftnlen, 
	    ftnlen, ftnlen);
    static integer nt2, nx2;


/* "space-time fourier-->space-time power spect */

    /* Parameter adjustments */
    x_dim1 = *n1;
    x_dim2 = *nx;
    x_dim3 = *n3;
    x_offset = 1 + x_dim1 * (1 + x_dim2 * (1 + x_dim3 * 1));
    x -= x_offset;
    sp_dim1 = *n1;
    sp_dim2 = *nx + 1;
    sp_dim3 = *n3;
    sp_offset = 1 + sp_dim1 * (1 + sp_dim2 * (1 + sp_dim3 * 1));
    sp -= sp_offset;

    /* Function Body */
    nx2 = *nx / 2;
    nt2 = *nt / 2;
    if (nt2 << 1 != *nt) {
	msgdmp_("E", "FST2SP", "INVALID ARRAY SIZE", (ftnlen)1, (ftnlen)6, (
		ftnlen)18);
    }
    if (nx2 << 1 != *nx) {
	msgdmp_("E", "FST2SP", "INVALID ARRAY size", (ftnlen)1, (ftnlen)6, (
		ftnlen)18);
    }

    i__1 = nt2;
    for (n = 1; n <= i__1; ++n) {
	i__2 = *n3;
	for (j = 1; j <= i__2; ++j) {
	    i__3 = nx2;
	    for (k = 0; k <= i__3; ++k) {
		i__4 = *n1;
		for (i__ = 1; i__ <= i__4; ++i__) {
		    if (k == 0 && n <= nt2 - 1) {
			p = x[i__ + ((j + ((n << 1) + 1) * x_dim3) * x_dim2 + 
				1) * x_dim1];
			q = x[i__ + ((j + ((n << 1) + 2) * x_dim3) * x_dim2 + 
				1) * x_dim1];
			r__ = 0.f;
			s = 0.f;
		    } else if (k == 0 && n == nt2) {
			p = x[i__ + ((j + (x_dim3 << 1)) * x_dim2 + 1) * 
				x_dim1];
			q = 0.f;
			r__ = 0.f;
			s = 0.f;
		    } else if (k <= nx2 - 1 && n <= nt2 - 1) {
			p = x[i__ + ((k << 1) + 1 + (j + ((n << 1) + 1) * 
				x_dim3) * x_dim2) * x_dim1];
			q = x[i__ + ((k << 1) + 1 + (j + ((n << 1) + 2) * 
				x_dim3) * x_dim2) * x_dim1];
			r__ = x[i__ + ((k << 1) + 2 + (j + ((n << 1) + 1) * 
				x_dim3) * x_dim2) * x_dim1];
			s = x[i__ + ((k << 1) + 2 + (j + ((n << 1) + 2) * 
				x_dim3) * x_dim2) * x_dim1];
		    } else if (k == nx2 && n <= nt2 - 1) {
			p = x[i__ + ((j + ((n << 1) + 1) * x_dim3) * x_dim2 + 
				2) * x_dim1];
			q = x[i__ + ((j + ((n << 1) + 2) * x_dim3) * x_dim2 + 
				2) * x_dim1];
			r__ = 0.f;
			s = 0.f;
		    } else if (k <= nx2 - 1 && n == nt2) {
			p = x[i__ + ((k << 1) + 1 + (j + (x_dim3 << 1)) * 
				x_dim2) * x_dim1];
			q = 0.f;
			r__ = x[i__ + ((k << 1) + 2 + (j + (x_dim3 << 1)) * 
				x_dim2) * x_dim1];
			s = 0.f;
		    } else if (k == nx2 && n == nt2) {
			p = x[i__ + ((j + (x_dim3 << 1)) * x_dim2 + 2) * 
				x_dim1];
			q = 0.f;
			r__ = 0.f;
			s = 0.f;
		    }
/* Computing 2nd power */
		    r__1 = p - s;
/* Computing 2nd power */
		    r__2 = q + r__;
		    sp[i__ + (nx2 + 1 - k + (j + n * sp_dim3) * sp_dim2) * 
			    sp_dim1] = (r__1 * r__1 + r__2 * r__2) * 2;
/* Computing 2nd power */
		    r__1 = p + s;
/* Computing 2nd power */
		    r__2 = q - r__;
		    sp[i__ + (nx2 + 1 + k + (j + n * sp_dim3) * sp_dim2) * 
			    sp_dim1] = (r__1 * r__1 + r__2 * r__2) * 2;
/* L10: */
		}
	    }
	}
    }

    return 0;
} /* fst2sp_ */

/* ********************************************************************** */

/* Subroutine */ int fst2ph_(real *ph, real *x, integer *n1, integer *nx, 
	integer *n3, integer *nt)
{
    /* System generated locals */
    integer x_dim1, x_dim2, x_dim3, x_offset, ph_dim1, ph_dim2, ph_dim3, 
	    ph_offset, i__1, i__2, i__3, i__4;

    /* Builtin functions */
    double atan2(doublereal, doublereal);

    /* Local variables */
    static integer i__, j, k, n;
    static real p, q, r__, s;
    extern /* Subroutine */ int msgdmp_(char *, char *, char *, ftnlen, 
	    ftnlen, ftnlen);
    static integer nt2, nx2;


/* " space-time fourier --> space-time phase */

    /* Parameter adjustments */
    x_dim1 = *n1;
    x_dim2 = *nx;
    x_dim3 = *n3;
    x_offset = 1 + x_dim1 * (1 + x_dim2 * (1 + x_dim3 * 1));
    x -= x_offset;
    ph_dim1 = *n1;
    ph_dim2 = *nx + 1;
    ph_dim3 = *n3;
    ph_offset = 1 + ph_dim1 * (1 + ph_dim2 * (1 + ph_dim3 * 1));
    ph -= ph_offset;

    /* Function Body */
    nx2 = *nx / 2;
    nt2 = *nt / 2;
    if (nt2 << 1 != *nt) {
	msgdmp_("E", "FST2PH", "INVALID ARRAY SIZE", (ftnlen)1, (ftnlen)6, (
		ftnlen)18);
    }
    if (nx2 << 1 != *nx) {
	msgdmp_("E", "FST2PH", "INVALID ARRAY size", (ftnlen)1, (ftnlen)6, (
		ftnlen)18);
    }

    i__1 = nt2;
    for (n = 1; n <= i__1; ++n) {
	i__2 = *n3;
	for (j = 1; j <= i__2; ++j) {
	    i__3 = nx2;
	    for (k = 0; k <= i__3; ++k) {
		i__4 = *n1;
		for (i__ = 1; i__ <= i__4; ++i__) {
		    if (k == 0 && n <= nt2 - 1) {
			p = x[i__ + ((j + ((n << 1) + 1) * x_dim3) * x_dim2 + 
				1) * x_dim1];
			q = x[i__ + ((j + ((n << 1) + 2) * x_dim3) * x_dim2 + 
				1) * x_dim1];
			r__ = 0.f;
			s = 0.f;
		    } else if (k == 0 && n == nt2) {
			p = x[i__ + ((j + (x_dim3 << 1)) * x_dim2 + 1) * 
				x_dim1];
			q = 0.f;
			r__ = 0.f;
			s = 0.f;
		    } else if (k <= nx2 - 1 && n <= nt2 - 1) {
			p = x[i__ + ((k << 1) + 1 + (j + ((n << 1) + 1) * 
				x_dim3) * x_dim2) * x_dim1];
			q = x[i__ + ((k << 1) + 1 + (j + ((n << 1) + 2) * 
				x_dim3) * x_dim2) * x_dim1];
			r__ = x[i__ + ((k << 1) + 2 + (j + ((n << 1) + 1) * 
				x_dim3) * x_dim2) * x_dim1];
			s = x[i__ + ((k << 1) + 2 + (j + ((n << 1) + 2) * 
				x_dim3) * x_dim2) * x_dim1];
		    } else if (k == nx2 && n <= nt2 - 1) {
			p = x[i__ + ((j + ((n << 1) + 1) * x_dim3) * x_dim2 + 
				2) * x_dim1];
			q = x[i__ + ((j + ((n << 1) + 2) * x_dim3) * x_dim2 + 
				2) * x_dim1];
			r__ = 0.f;
			s = 0.f;
		    } else if (k <= nx2 - 1 && n == nt2) {
			p = x[i__ + ((k << 1) + 1 + (j + (x_dim3 << 1)) * 
				x_dim2) * x_dim1];
			q = 0.f;
			r__ = x[i__ + ((k << 1) + 2 + (j + (x_dim3 << 1)) * 
				x_dim2) * x_dim1];
			s = 0.f;
		    } else if (k == nx2 && n == nt2) {
			p = x[i__ + ((j + (x_dim3 << 1)) * x_dim2 + 2) * 
				x_dim1];
			q = 0.f;
			r__ = 0.f;
			s = 0.f;
		    }
		    if (q + r__ != 0.f || p - s != 0.f) {
			ph[i__ + (nx2 + 1 - k + (j + n * ph_dim3) * ph_dim2) *
				 ph_dim1] = atan2(q + r__, p - s);
		    } else {
			ph[i__ + (nx2 + 1 - k + (j + n * ph_dim3) * ph_dim2) *
				 ph_dim1] = 0.f;
		    }
		    if (q - r__ != 0.f || p + s != 0.f) {
			ph[i__ + (nx2 + 1 + k + (j + n * ph_dim3) * ph_dim2) *
				 ph_dim1] = atan2(q - r__, p + s);
		    } else {
			ph[i__ + (nx2 + 1 + k + (j + n * ph_dim3) * ph_dim2) *
				 ph_dim1] = 0.f;
		    }
/* L10: */
		}
	    }
	}
    }

    return 0;
} /* fst2ph_ */

